package net.faintedge.radial.examples;

import net.faintedge.radial.Context;
import net.faintedge.radial.Grid2D;
import net.faintedge.radial.RadialApplication;
import net.faintedge.radial.components.Position;
import net.faintedge.radial.components.RenderSprite;

import com.artemis.Entity;
import com.artemis.World;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.backends.lwjgl.LwjglApplication;
import com.badlogic.gdx.backends.lwjgl.LwjglApplicationConfiguration;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer.ShapeType;

public class SimpleRender extends RadialApplication {

	private Grid2D grid;

	@Override
	public void create() {
		super.create();
		
		Context context = super.getContext();
		World world = context.getWorld();
		
		Entity e = world.createEntity();
		e.addComponent(new Position(0, 0));
		e.addComponent(new RenderSprite().fromTexture(Gdx.files.internal("data/libgdx.png"), 0, 0, 512, 275, 0.9f, 0.9f * (275.0f/512.0f)).toRender());
		e.addToWorld();
		
		grid = new Grid2D(context);
	}
	
	@Override
	public void render() {
		super.render();
		
		grid.render();

		Context context = super.getContext();
		ShapeRenderer shapeRenderer = context.getShapeRenderer();
		
		shapeRenderer.setProjectionMatrix(context.getCurrentCamera().combined);
		shapeRenderer.begin(ShapeType.Rectangle);
		shapeRenderer.setColor(new Color(0, 1, 0, 1));
		shapeRenderer.rect(0f, 0f, 0.5f, 0.5f);
		shapeRenderer.end();
	}
	
	public static void main(String[] args) {
		LwjglApplicationConfiguration cfg = new LwjglApplicationConfiguration();
		cfg.title = "SimpleRender";
		cfg.width = 800;
		cfg.height = 600;
		
		new LwjglApplication(new SimpleRender(), cfg);
	}
	
}
