package net.faintedge.radial;

import com.badlogic.gdx.ApplicationListener;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Camera;
import com.badlogic.gdx.graphics.GL10;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

public class RadialApplication implements ApplicationListener {
	
	private Context context;
	private Timer timer;

	@Override
	public void create() {
		timer = new Timer();
		
		context = new Context();
		context.create();
		context.activate();
	}

	@Override
	public void dispose() {
		context.dispose();
	}

	@Override
	public void pause() {
		// TODO Auto-generated method stub

	}

	@Override
	public void render() {
		float tpf = timer.tickSeconds();
		
		context.getInputManager().process(tpf);
		context.getWorld().process();
		
		Gdx.gl.glClearColor(0, 0, 0, 1);
		Gdx.gl.glClear(GL10.GL_COLOR_BUFFER_BIT);
		
		SpriteBatch batch = context.getBatch();
		Camera camera = context.getCurrentCamera();
		
		batch.setProjectionMatrix(camera.combined);
		batch.begin();

		// draw stuff here
		context.getRenderingSystem().process();

		batch.end();
	}

	@Override
	public void resize(int width, int height) {
		// TODO Auto-generated method stub

	}

	@Override
	public void resume() {
		// TODO Auto-generated method stub

	}

	public Context getContext() {
		return context;
	}
}
