package net.faintedge.radial;

import java.util.HashMap;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.Texture.TextureFilter;

public final class ResourceManager {

	private ResourceManager () {}
	private static ResourceManager instance = null;
	public static ResourceManager getInstance() {
		if (instance == null) { instance = new ResourceManager(); }
		return instance;
	}
	
	private HashMap<FileHandle, Texture> textures = new HashMap<FileHandle, Texture>();
	
	public Texture getTexture(FileHandle file) {
		Texture texture = textures.get(file);
		if (texture == null) {
			texture = new Texture(file);
			texture.setFilter(TextureFilter.Linear, TextureFilter.Linear);
			textures.put(file, texture);
		}
		return texture;
	}

	public void disposeAll() {
		for (Texture texture : textures.values()) {
			texture.dispose();
		}
	}
	
}
