package net.faintedge.radial.components;

import net.faintedge.radial.ResourceManager;
import net.faintedge.radial.systems.RenderingContext;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureRegion;

public class RenderSprite extends RenderStrategy {

	private Sprite sprite;
	
	public RenderSprite() {
		
	}
	
	public RenderSprite(Sprite sprite) {
		this.sprite = sprite;
	}
	
	@Override
	public void draw(RenderingContext context, Position position) {
		sprite.setPosition(position.getX() - sprite.getOriginX(), position.getY() - sprite.getOriginY());
		sprite.draw(context.getBatch());
	}

	public RenderSprite fromTexture(FileHandle textureFile,
			int textureX, int textureY, int textureWidth, int textureHeight,
			float spriteWidth, float spriteHeight) {
		
		Texture texture = ResourceManager.getInstance().getTexture(textureFile);
		TextureRegion region = new TextureRegion(texture, textureX, textureY, textureWidth, textureHeight);

		sprite = new Sprite(region);
		sprite.setSize(spriteWidth, spriteHeight);
		sprite.setOrigin(sprite.getWidth()/2, sprite.getHeight()/2);
		//sprite.setPosition(-sprite.getWidth()/2, -sprite.getHeight()/2);
		return this;
	}

	public Sprite getSprite() {
		return sprite;
	}

	public void setSprite(Sprite sprite) {
		this.sprite = sprite;
	}
	
}
