package net.faintedge.radial.systems;

import net.faintedge.radial.components.Camera;
import net.faintedge.radial.components.Position;

import com.artemis.Aspect;
import com.artemis.ComponentMapper;
import com.artemis.Entity;
import com.artemis.annotations.Mapper;
import com.artemis.systems.EntityProcessingSystem;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

public class CameraSystem extends EntityProcessingSystem {
	@Mapper ComponentMapper<Position> pm;
	@Mapper ComponentMapper<Camera> cm;

	private RenderingContext context = new RenderingContext();

	public CameraSystem() {
		super(Aspect.getAspectForAll(Position.class, Camera.class));
	}

	protected void process(Entity e) {
		Position position = pm.get(e);
		Camera camera = cm.get(e);
		camera.getCamera().position.set(position.getX(), position.getY(), 0);
	}

	public void setSpriteBatch(SpriteBatch batch) {
		this.context.setBatch(batch);
	}

	public RenderingContext getContext() {
		return context;
	}
}