package net.faintedge.radial.systems;

import net.faintedge.radial.components.Position;
import net.faintedge.radial.components.Render;

import com.artemis.Aspect;
import com.artemis.ComponentMapper;
import com.artemis.Entity;
import com.artemis.annotations.Mapper;
import com.artemis.systems.EntityProcessingSystem;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

public class RenderingSystem extends EntityProcessingSystem {
	@Mapper ComponentMapper<Position> pm;
	@Mapper ComponentMapper<Render> rm;

	private RenderingContext context = new RenderingContext();

	public RenderingSystem() {
		super(Aspect.getAspectForAll(Position.class, Render.class));
	}

	protected void process(Entity e) {
		Position position = pm.get(e);
		Render render = rm.get(e);
		render.draw(context, position);
	}

	public void setSpriteBatch(SpriteBatch batch) {
		this.context.setBatch(batch);
	}

	public RenderingContext getContext() {
		return context;
	}
}